## com.saxonica.codegen
Class LocalVariableReferenceCompiler

    java.lang.Object
      com.saxonica.codegen.ExpressionCompiler
          com.saxonica.codegen.SequenceExpressionCompiler
              com.saxonica.codegen.LocalVariableReferenceCompiler

    public class LocalVariableReferenceCompiler

extends SequenceExpressionCompiler

Generate Java code to implement an XPath local variable reference

Constructor Summary
`LocalVariableReferenceCompiler()`

Method Summary
`void` `compilePush(CompilerService compiler, Expression expr)` Generate Java code to execute the expression in push mode, that is, code to write events to the current output Receiver
`java.lang.String` `compileToCharSequence(CompilerService compiler, Expression expr)` Generate Java code to evaluate the expression as a CharSequence
`java.lang.String` `compileToItem(CompilerService compiler, Expression expr)` Generate Java code to evaluate the expression as an Item
`java.lang.String` `compileToIterator(CompilerService compiler, Expression expr)` Generate Java code to evaluate the expression as a SequenceIterator
`java.lang.String` `compileToValueRepresentation(CompilerService compiler, Expression expr)` Generate Java code to evaluate the expression as a ValueRepresentation

Methods inherited from class com.saxonica.codegen.SequenceExpressionCompiler
`compileToEffectiveBooleanValue`

Methods inherited from class com.saxonica.codegen.ExpressionCompiler
`compileAsLoop`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### LocalVariableReferenceCompiler

    public LocalVariableReferenceCompiler()

Method Detail

### compileToIterator

    public java.lang.String compileToIterator(CompilerService compiler,
                                              Expression expr)

  Description copied from class: `ExpressionCompiler`
  Generate Java code to evaluate the expression as a SequenceIterator

  Specified by:
    `compileToIterator` in class `ExpressionCompiler`
  Parameters:
    `compiler` - the compiler service
    `expr` - the XPath expression to be compiled
  Returns:
    a simple Java expression (usually the name of a variable that has been declared) which will be of class `SequenceIterator`, and which at run-time will hold an iterator over the the value of the XPath expression

### compileToValueRepresentation

    public java.lang.String compileToValueRepresentation(CompilerService compiler,
                                                         Expression expr)

  Description copied from class: `ExpressionCompiler`
  Generate Java code to evaluate the expression as a ValueRepresentation

  Overrides:
    `compileToValueRepresentation` in class `ExpressionCompiler`
  Parameters:
    `compiler` - the compiler service
    `expr` - the expression to be compiled
  Returns:
    a simple Java expression (usually the name of a variable that has been declared) which will be of class `ValueRepresentation`, and which at run-time will hold the value of the expression

### compileToItem

    public java.lang.String compileToItem(CompilerService compiler,
                                          Expression expr)

  Description copied from class: `ExpressionCompiler`
  Generate Java code to evaluate the expression as an Item

  Overrides:
    `compileToItem` in class `SequenceExpressionCompiler`
  Parameters:
    `compiler` - the compiler service
    `expr` - the expression to be compiled
  Returns:
    a simple Java expression (usually the name of a variable that has been declared) which will be of class `Item`, and which will hold the value of the expression at run-time (or hold null, representing an empty sequence).

### compilePush

    public void compilePush(CompilerService compiler,
                            Expression expr)

  Description copied from class: `ExpressionCompiler`
  Generate Java code to execute the expression in push mode, that is, code to write events to the current output Receiver

  Overrides:
    `compilePush` in class `SequenceExpressionCompiler`
  Parameters:
    `compiler` - the compiler service
    `expr` - the expression to be compiled

### compileToCharSequence

    public java.lang.String compileToCharSequence(CompilerService compiler,
                                                  Expression expr)

  Description copied from class: `ExpressionCompiler`
  Generate Java code to evaluate the expression as a CharSequence

  Overrides:
    `compileToCharSequence` in class `SequenceExpressionCompiler`
  Parameters:
    `compiler` - the compiler service
    `expr` - the XPath expression to be compiled
  Returns:
    a simple Java expression (usually the name of a variable that has been declared, or a string literal) which will be of class `CharSequence`, and which will hold the string value of the XPath expression at run-time

Copyright (c) Saxonica Limited. All rights reserved.